// ===========================================================================
//	FrDropApp.h						1994 Metrowerks Inc. All rights reserved.
// ===========================================================================

#pragma once

#include "LModelObject.h"

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

#include "ResAnomalyDefaults.h"

class	FrDropApp : public LModelObject {
public:
					FrDropApp();
	
	void			Run();

	virtual void			HandleAppleEvent(
									const AppleEvent	&inAppleEvent,
									AppleEvent			&outAEReply,
									AEDesc				&outResult,
									Int32				inAENumber);
	
protected:
	Boolean			mRunning;
	Handle			mTextBeginLine;
	Handle			mTextIDequals;
	Handle			mTextIDend;
	Handle			mOutputHeaderStart;
	Handle			mOutputHeaderStop;
	
	ResAnomalyPrefs	mCurrentPrefs;

	virtual void	StartUp();
	
	void			ReadPrefs();
	
	// * utils
	void			MapToValidC(Str255 ioString);
	void			MapToValidC(long inLength, void *ioChars);
	
	
	
	void			DoAEOpenDoc(const AppleEvent &inAppleEvent,
										AppleEvent &outARReply,
										long inAENumber);
	virtual void	OpenDocument(FSSpec *inMacFSSpec);
	virtual void	DoQuit();
};